/**
 * Copyright 2011 Adrian Witas
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.abstractmeta.code.g.core.code;

import org.abstractmeta.code.g.code.JavaField;

import java.lang.annotation.Annotation;
import java.lang.reflect.Type;
import java.util.List;


/**
 * Provides implementation of interface org.abstractmeta.toolbox.code.JavaField
 * This class has been auto generated by g-toolbox.
 */
public class JavaFieldImpl implements JavaField {


    private final Type type;

    private final String initBody;

    private final List<String> modifiers;

    private final String name;

    private final List<Annotation> annotations;

    private final List<String> documentation;
    
    private final boolean immutable;

    public JavaFieldImpl(Type type, String initBody, List<String> modifiers, String name, List<Annotation> annotations, List<String> documentation, boolean immutable) {
        this.type = type;
        this.initBody = initBody;
        this.modifiers = modifiers;
        this.name = name;
        this.annotations = annotations;
        this.documentation = documentation;
        this.immutable = immutable;
    }

    public Type getType() {
        return this.type;
    }

    @Override
    public boolean isImmutable() {
        return immutable;
    }

    public String getInitBody() {
        return this.initBody;
    }

    public List<String> getModifiers() {
        return this.modifiers;
    }

    public String getName() {
        return this.name;
    }

    public List<Annotation> getAnnotations() {
        return this.annotations;
    }

    public List<String> getDocumentation() {
        return this.documentation;
    }

}